(*
 * <COPYRIGHT>
 * Copyright 2005 Gerd Stolpmann
 *
 * <GPL>
 * This file is part of UMLMON-Web.
 *
 * UMLMON-Web is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * UMLMON-Web is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with UMLMON-Web; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * </>
 *)

(* $Id: main_cgi.ml 121 2005-06-12 13:56:40Z gerd $
 * ----------------------------------------------------------------------
 *
 *)

open Wd_run_cgi


(* Initialization: *)

(* WDialog processing: *)

let main ~uifile () =
  let cgi =
    new Netcgi.std_activation
      ~operating_type:Netcgi.buffered_transactional_optype
      ()
  in
  match cgi # argument_value "fn" with
    | "termout" ->
	Termout.process cgi
    | "termin" ->
	run
	  ~cgi
	  ~uifile
	  ~charset:`Enc_iso88591
	  ~error_page:(fun ch err -> !Init.print_error ch err)
	  ~reg:(fun universe ->
		  Init.reg universe;
		  universe # application # set_start_dialog_name "termin")
	  ()
    | _ ->
	run
	  ~cgi
	  ~uifile
	  ~charset:`Enc_iso88591
	  ~error_page:(fun ch err -> !Init.print_error ch err)
	  ~reg:Init.reg
	  ()
;;
